// package: models.proto.cofd.api
// file: cofd_api.proto

import * as jspb from "google-protobuf";
import * as cofd_pb from "./cofd_pb";

export class BasicInfo extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  getGender(): string;
  setGender(value: string): void;

  getConcept(): string;
  setConcept(value: string): void;

  getChronicle(): string;
  setChronicle(value: string): void;

  getAge(): number;
  setAge(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): BasicInfo.AsObject;
  static toObject(includeInstance: boolean, msg: BasicInfo): BasicInfo.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: BasicInfo, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): BasicInfo;
  static deserializeBinaryFromReader(message: BasicInfo, reader: jspb.BinaryReader): BasicInfo;
}

export namespace BasicInfo {
  export type AsObject = {
    name: string,
    gender: string,
    concept: string,
    chronicle: string,
    age: number,
  }
}

export class Attributes extends jspb.Message {
  getStrength(): number;
  setStrength(value: number): void;

  getDexterity(): number;
  setDexterity(value: number): void;

  getStamina(): number;
  setStamina(value: number): void;

  getIntelligence(): number;
  setIntelligence(value: number): void;

  getWits(): number;
  setWits(value: number): void;

  getResolve(): number;
  setResolve(value: number): void;

  getPresence(): number;
  setPresence(value: number): void;

  getManipulation(): number;
  setManipulation(value: number): void;

  getComposure(): number;
  setComposure(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Attributes.AsObject;
  static toObject(includeInstance: boolean, msg: Attributes): Attributes.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Attributes, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Attributes;
  static deserializeBinaryFromReader(message: Attributes, reader: jspb.BinaryReader): Attributes;
}

export namespace Attributes {
  export type AsObject = {
    strength: number,
    dexterity: number,
    stamina: number,
    intelligence: number,
    wits: number,
    resolve: number,
    presence: number,
    manipulation: number,
    composure: number,
  }
}

export class UpdateAttributeRequest extends jspb.Message {
  getCharacterUsername(): string;
  setCharacterUsername(value: string): void;

  getCharacterId(): number;
  setCharacterId(value: number): void;

  getAttributeName(): string;
  setAttributeName(value: string): void;

  getAttributeValue(): number;
  setAttributeValue(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateAttributeRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateAttributeRequest): UpdateAttributeRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateAttributeRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateAttributeRequest;
  static deserializeBinaryFromReader(message: UpdateAttributeRequest, reader: jspb.BinaryReader): UpdateAttributeRequest;
}

export namespace UpdateAttributeRequest {
  export type AsObject = {
    characterUsername: string,
    characterId: number,
    attributeName: string,
    attributeValue: number,
  }
}

export class Skills extends jspb.Message {
  clearPhysicalSkillsList(): void;
  getPhysicalSkillsList(): Array<cofd_pb.CofdSheet.Skill>;
  setPhysicalSkillsList(value: Array<cofd_pb.CofdSheet.Skill>): void;
  addPhysicalSkills(value?: cofd_pb.CofdSheet.Skill, index?: number): cofd_pb.CofdSheet.Skill;

  clearMentalSkillsList(): void;
  getMentalSkillsList(): Array<cofd_pb.CofdSheet.Skill>;
  setMentalSkillsList(value: Array<cofd_pb.CofdSheet.Skill>): void;
  addMentalSkills(value?: cofd_pb.CofdSheet.Skill, index?: number): cofd_pb.CofdSheet.Skill;

  clearSocialSkillsList(): void;
  getSocialSkillsList(): Array<cofd_pb.CofdSheet.Skill>;
  setSocialSkillsList(value: Array<cofd_pb.CofdSheet.Skill>): void;
  addSocialSkills(value?: cofd_pb.CofdSheet.Skill, index?: number): cofd_pb.CofdSheet.Skill;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Skills.AsObject;
  static toObject(includeInstance: boolean, msg: Skills): Skills.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Skills, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Skills;
  static deserializeBinaryFromReader(message: Skills, reader: jspb.BinaryReader): Skills;
}

export namespace Skills {
  export type AsObject = {
    physicalSkillsList: Array<cofd_pb.CofdSheet.Skill.AsObject>,
    mentalSkillsList: Array<cofd_pb.CofdSheet.Skill.AsObject>,
    socialSkillsList: Array<cofd_pb.CofdSheet.Skill.AsObject>,
  }
}

export class SkillUpdate extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  hasSkill(): boolean;
  clearSkill(): void;
  getSkill(): cofd_pb.CofdSheet.Skill | undefined;
  setSkill(value?: cofd_pb.CofdSheet.Skill): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SkillUpdate.AsObject;
  static toObject(includeInstance: boolean, msg: SkillUpdate): SkillUpdate.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SkillUpdate, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SkillUpdate;
  static deserializeBinaryFromReader(message: SkillUpdate, reader: jspb.BinaryReader): SkillUpdate;
}

export namespace SkillUpdate {
  export type AsObject = {
    name: string,
    skill?: cofd_pb.CofdSheet.Skill.AsObject,
  }
}

export class UpdateSkillValueRequest extends jspb.Message {
  getCharacterUsername(): string;
  setCharacterUsername(value: string): void;

  getCharacterId(): number;
  setCharacterId(value: number): void;

  getSkillName(): string;
  setSkillName(value: string): void;

  getSkillValue(): number;
  setSkillValue(value: number): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): UpdateSkillValueRequest.AsObject;
  static toObject(includeInstance: boolean, msg: UpdateSkillValueRequest): UpdateSkillValueRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: UpdateSkillValueRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): UpdateSkillValueRequest;
  static deserializeBinaryFromReader(message: UpdateSkillValueRequest, reader: jspb.BinaryReader): UpdateSkillValueRequest;
}

export namespace UpdateSkillValueRequest {
  export type AsObject = {
    characterUsername: string,
    characterId: number,
    skillName: string,
    skillValue: number,
  }
}

export class SkillSpecializationsUpdate extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  clearSpecializationsList(): void;
  getSpecializationsList(): Array<string>;
  setSpecializationsList(value: Array<string>): void;
  addSpecializations(value: string, index?: number): string;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): SkillSpecializationsUpdate.AsObject;
  static toObject(includeInstance: boolean, msg: SkillSpecializationsUpdate): SkillSpecializationsUpdate.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: SkillSpecializationsUpdate, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): SkillSpecializationsUpdate;
  static deserializeBinaryFromReader(message: SkillSpecializationsUpdate, reader: jspb.BinaryReader): SkillSpecializationsUpdate;
}

export namespace SkillSpecializationsUpdate {
  export type AsObject = {
    name: string,
    specializationsList: Array<string>,
  }
}

export class Condition extends jspb.Message {
  getName(): string;
  setName(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): Condition.AsObject;
  static toObject(includeInstance: boolean, msg: Condition): Condition.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: Condition, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): Condition;
  static deserializeBinaryFromReader(message: Condition, reader: jspb.BinaryReader): Condition;
}

export namespace Condition {
  export type AsObject = {
    name: string,
  }
}

